﻿-- vim: ts=2 sw=2 ai et enc=utf8 fenc=utf8

if not RaidChecklist then return end

local L = RaidChecklistStrings
local NAME = L["Raid Checklist"]
local CfgHandler = {}

function CfgHandler:GetVal (info)
    local varname = info[#info]
    return RaidChecklistDB.profile[varname]
end

function CfgHandler:SetVal (info, v)
    local varname = info[#info]
    RaidChecklistDB.profile[varname] = v
    if RaidChecklist.OnConfigChange then
      RaidChecklist:OnConfigChange ()
    end
end

local config = {
  type = 'group',
  handler = CfgHandler,
  get = "GetVal", set = "SetVal",
  args = {
    config = {
      type = 'group',
      name = L.CONFIG,
      args = {
        hdr = { type = 'description', name = "Anyia of HordeYakka (Jubei'Thos) - Design, coding and partial research\nMalazee - Main research and ability checking", order = 1 },
        blank = { type = 'header', name = "", order = 10 },
        anchor_locked = {
          type = 'toggle', 
          name = L.ANCHORLOCKED,
          desc = L.ANCHORLOCKEDDESC,
          order = 50
        },
        show_anchor = {
          type = 'toggle',
          name = L.SHOWANCHOR,
          desc = L.SHOWANCHORDESC,
          order = 60
        },
        open_direction = {
          type = 'select',
          name = L.OPENDIRECTION,
          desc = L.OPENDIRECTIONDESC,
          values = { DOWNRIGHT = L.DOWNRIGHT, DOWNLEFT = L.DOWNLEFT, UPRIGHT = L.UPRIGHT, UPLEFT = L.UPLEFT },
          order = 100
        },
        font_size = {
          type = 'select',
          name = L.FONTSIZE,
          desc = L.FONTSIZEDESC,
          values = { normal = L.NORMAL, small = L.SMALL },
          order = 120
        },
        reset_anchor = {
          type = 'execute',
          name = L.RESETANCHOR,
          desc = L.RESETANCHORDESC,
          func = function ()
            RaidChecklist.button:ClearAllPoints ()
            RaidChecklist.button:SetPoint ("CENTER", 0, 0)
            RaidChecklistDB.profile.xoffs = 0
            RaidChecklistDB.profile.yoffs = 0
          end,
          order = 300
        },
        blank2 = { type = 'header', name = "", order = 400 },
        hdr2 = { type = 'description', name = L.FILTERGROUPS, order = 401 },
        group1 = { type = 'toggle', name = L.GROUP.." 1", order = 411 },
        group2 = { type = 'toggle', name = L.GROUP.." 2", order = 412 },
        group3 = { type = 'toggle', name = L.GROUP.." 3", order = 413 },
        group4 = { type = 'toggle', name = L.GROUP.." 4", order = 414 },
        group5 = { type = 'toggle', name = L.GROUP.." 5", order = 415 },
        group6 = { type = 'toggle', name = L.GROUP.." 6", order = 416 },
        group7 = { type = 'toggle', name = L.GROUP.." 7", order = 417 },
        group8 = { type = 'toggle', name = L.GROUP.." 8", order = 418 },
        blank3 = { type = 'header', name = "", order = 900 },
        tail = { type = 'description', name = "With special thanks to:\n Threepwoood - French translations\n Morrtin - German translations\n 순듸windrunner(KR) - Korean translations", order = 902 },
      }
    }
  }
}

RaidChecklist.dbdefaults = {
  profile = {
    show_anchor = true,
    anchor_locked = false,
    open_direction = "DOWNRIGHT",
    font_size = "normal",
    anchorpoint = "CENTER",
    relpoint = "CENTER",
    x = 0,
    y = 0,
    group1 = true,
    group2 = true,
    group3 = true,
    group4 = true,
    group5 = true,
    group6 = false,
    group7 = false,
    group8 = false,
  }
}

LibStub ("AceConfigRegistry-3.0"):RegisterOptionsTable (NAME, config)
RaidChecklist.cfgdlg = LibStub ("AceConfigDialog-3.0")
RaidChecklist.cfgdlg:AddToBlizOptions (NAME, nil, nil, "config")

